#ifndef _Aisap37_H_
#define _Aisap37_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AISA37_MAX_SLOTS	16
#define	AISA37_SLOT_AUTO	((WORD) ~0U)
#define	AISA37_PORT_0		0
#define	AISA37_PORT_1		1

// G[R[h
#define AISA37_SUCCESS				0	// ُȂ
#define AISA37_ERR_SYSTEM			1	// GetLastError sĂ
#define AISA37_ERR_NO_DEVICE		2	// gp\ȃfoCXȂ
#define AISA37_ERR_IN_USE			3	// w肳ꂽXbg͎gp
#define AISA37_ERR_INVALID_SLOT		4	// Ș_Xbgԍ
#define AISA37_ERR_RESOURCE			5	// \[XG[
#define AISA37_ERR_INVALID_PORT		6	// ȃ|[gԍ
#define AISA37_ERR_INVALID_ARGUMENT	7	// Ȉ

#define AISA37_MAX_MEM		9
#define AISA37_MAX_IO		20
#define AISA37_MAX_IRQ		7
#define AISA37_MAX_DMA		7

//======================================================================
// \[X\
//======================================================================
typedef struct {
	DWORD	dwNumMemWindows;				   // EChE	gp
	DWORD	dwMemBase		[AISA37_MAX_MEM];  // MWx[XAhX		gp
	DWORD	dwMemLength		[AISA37_MAX_MEM];  // MW					gp
	DWORD	dwMemAttrib		[AISA37_MAX_MEM];  // MW				gp
	DWORD	dwNumIOPorts;					   // I/O|[g
	DWORD	dwIOPortBase	[AISA37_MAX_IO];   // I/O|[gx[XAhX
	DWORD	dwIOPortLength	[AISA37_MAX_IO];   // I/O|[g
	DWORD	dwNumIRQs;						   // IRQ					gp
	DWORD	dwIRQRegisters	[AISA37_MAX_IRQ];  // IRQXg				gp
	DWORD	dwIRQAttrib		[AISA37_MAX_IRQ];  // IRQXg			gp
	DWORD	dwNumDMAs;						   // DMA`l			gp
	DWORD	dwDMALst		[AISA37_MAX_DMA];  // DMA`lXg		gp
	DWORD	dwDMAAttrib		[AISA37_MAX_DMA];  // DMA`lXg	gp
	DWORD	dwReserved1		[3];			   // \					gp
} AISA37RESOURCE;

typedef		AISA37RESOURCE *PAISA37R;
typedef		AISA37RESOURCE FAR *LPAISA37R;

//-- ȉAPI --
//======================================================================
// DLL  Driver ̃o[W擾
//======================================================================
BOOL WINAPI Aisa37GetVersion(
	PDWORD		pdwDllVer,		// DLL Version
	PDWORD		pdwDrvVer );	// Driver Version

//======================================================================
// foCXgp錾
//======================================================================
BOOL WINAPI Aisa37Create(
	PWORD pwLogSlot );			// Xbgԍ( 0`15 or SLOT_AUTO )

//======================================================================
// foCXJ
//======================================================================
BOOL WINAPI Aisa37Close(
	WORD wLogSlot );			// Xbgԍ( 0`15 )

//======================================================================
// \[X擾
//======================================================================
BOOL WINAPI Aisa37GetResource(
	WORD	wLogSlot,			// Slot
	AISA37RESOURCE *pRes );		// \[X\̂̃|C^

//======================================================================
// C|[g
//======================================================================
BOOL WINAPI Aisa37InPort(
	WORD	wLogSlot,			// Slot
	DWORD	dwPort,				// |[gԍ( 0 - 1 )
	PBYTE	pbValue );			// l

//======================================================================
// AEg|[g
//======================================================================
BOOL WINAPI Aisa37OutPort(
	WORD	wLogSlot,			// Slot
	DWORD	dwPort,				// |[gԍ( 0 - 1 )
	BYTE	bValue );			// l

//======================================================================
// Ōw肳ꂽXbgŔsꂽG[R[ho
//======================================================================
DWORD WINAPI Aisa37GetLastError(
	WORD	wLogSlot );			// Slot

#ifdef __cplusplus
}
#endif
#endif
